/*
 * Copyright 2013 by Kappich Systemberatung Aachen
 * 
 * This file is part of de.bsvrz.dav.daf.
 * 
 * de.bsvrz.dav.daf is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * de.bsvrz.dav.daf is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with de.bsvrz.dav.daf; If not, see <http://www.gnu.org/licenses/>.

 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436 
 * mail: <info@kappich.de>
 */

package de.bsvrz.dav.daf.communication.lowLevel.telegrams;

/**
 * @author Kappich Systemberatung
 * @version $Revision: 0000 $
 */
public enum TransmitterSubscriptionType {
	/**
	 * Anmeldung als Sender bei einem remote-Zentraldatenverteiler, welcher die Funktion einer Senke übernimmt.
	 */
	Sender(TransmitterSubscriptionsConstants.SENDER_SUBSCRIPTION),
	/**
	 * Anmeldung als Empfänger bei einem remote-Zentraldatenverteiler, welcher die Funktion einer Quelle übernimmt.
	 */
	Receiver(TransmitterSubscriptionsConstants.RECEIVER_SUBSCRIPTION);

	private final byte _byteValue;

	TransmitterSubscriptionType(final byte byteValue) {

		_byteValue = byteValue;
	}

	public byte toByte(){
		return _byteValue;
	}

	public static TransmitterSubscriptionType fromByte(byte b){
		switch(b){
			case TransmitterSubscriptionsConstants.SENDER_SUBSCRIPTION: return Sender;
			case TransmitterSubscriptionsConstants.RECEIVER_SUBSCRIPTION: return Receiver;
			default:
			throw new IllegalArgumentException("Unbenannter Anmeldungstyp: " + b);
		}
	}
}
